// ***********************************************************************
// File : 		demo.C
// Purpose : 	չO{
// ***********************************************************************

#define __dsPIC30F4011__

#include 	<p30F4011.h>
#include 	"C30EVM_LCD.h"			// NLCD禡쫬ŧiɮקtJ 
#include	<timer.h>				// NTimer禡쫬ŧiɮקtJ
#include	<adc10.h>				// Nadc10禡쫬ŧiɮקtJ
#include	<pwm.h>					// Npwm禡쫬ŧiɮקtJ
#include 	<uart.h>				// NUART禡쫬ŧiɮקtJ 

#define		FCY 	7372800 * 2		// ]ϥWvN~ 7.3728 MHz * 8 Ҧ , C@Og 4  clock
									// ҥH FCY =  (7.3728 * 8 / 4 ) MHz = 7372800* 2

#define	LED_DATA		LATE
#define	DIR_LED_DATA	TRISE

#define	LED7		LATBbits.LATB4 		//wqLED7PLED8SwX}줸NŸA
#define	LED8		LATBbits.LATB5 		//H[j{iŪʻP²
#define	DIR_LED7	TRISBbits.TRISB4 	//wqDIR_LED7PDIR_LED8SwXJ}줸
#define	DIR_LED8	TRISBbits.TRISB5	//V줸NŸ

#define	SW5				PORTEbits.RE8
#define	SW6				PORTBbits.RB3
#define	DIR_SW5			TRISEbits.TRISE8 
#define	DIR_SW6			TRISBbits.TRISB3

#define	INPUT		1
#define	OUTPUT		0		

   	_FOSC(CSW_FSCM_OFF & XT_PLL8);   //	XT with 8xPLL oscillator, Failsafe clock off
   	_FWDT(WDT_OFF);                  //	Watchdog timer disabled
  	_FBORPOR(PBOR_OFF & MCLR_EN);    //	Brown-out reset disabled, MCLR reset enabled
   	_FGS(CODE_PROT_OFF);             //	Code protect disabled

const char	My_String1[]="C30 Demo ADC SW " ;	// ŧir Program Memory (] const ŧi)
	  char	My_String2[]="VR1:    VR2:     " ;	// ŧir Data Memory
	  char	My_String3[]="C30 Demo PWM LED " ;	// ŧir Data Memory
	  char	My_String4[]="Welcome C30 Demo " ;	// ŧir Data Memory
	  char	My_String5[]="SW5:ADC SW6:PWM  " ;	// ŧir Data Memory
	  char	My_String6[]="Press KB\r\n" ;	// ŧir Data Memory
	  char	My_String7[]="UART OK\r\n" ;	// ŧir Data Memory
	  char	My_String8[]="UART 9600-8-N-1  " ;	// ŧir Data Memory
	  char	My_String9[]="Check UART RX\r\n" ;	// ŧir Data Memory

void	Init_UART(void) ;
void	Init_ADC1(void) ;
void	Init_ADC2(void) ;
void	Show_ADC1(void) ;
void	Show_ADC2(void) ;
unsigned char	AN_Key(unsigned int) ;
void 	Init_MCPWM(void);

unsigned int No_Sec;

void _ISR _T1Interrupt(void)		//Timer1_Ƶ{
{
	No_Sec += 1 ;				//Wɶ
	IFS0bits.T1IF = 0 ;		//M_X
}

int	main( void )
{
	ADPCFG = 0xffff ;				// ADPCFG = 1111 1111 1111 1111 
									// Ҧ AD Input W Digital I/O
	
	LED_DATA = 0xfffe ;				// NXJPORTEXȪlơALED(RE0) ON
	DIR_LED_DATA &= 0xfff0 ;		// Ns LED1 to LED4 ( RE0 .. RE3 ) } PIN
									// ] OUTPUT
	DIR_SW5  = INPUT ;
	DIR_SW6  = INPUT ;

	TRISBbits.TRISB3=INPUT;
	TRISDbits.TRISD0=OUTPUT;
	LATDbits.LATD0=1;

	DIR_LED7 = OUTPUT;
	DIR_LED8 = OUTPUT;
	LED7=LED8=1;

	ConfigIntTimer1( T1_INT_PRIOR_1 & T1_INT_ON ) ;			// Timer1 _uų] 0 (̧C)
																// Timer1 _ OFF ( POLLING) 
	OpenTimer1( T1_ON & T1_IDLE_STOP & T1_GATE_OFF & 			// Timer1  Period ]C 1ms 
				T1_PS_1_1 & T1_SYNC_EXT_OFF & T1_SOURCE_INT ,	// Gpƽd](FCY/ 1000)
				FCY/1000 ) ;

	No_Sec=0;

	Init_UART( ) ;										//  UART Ҳէ@lƳ]w

	OpenLCD( ) ;										// ϥ OpenLCD( ) LCD Ҳէ@lƳ]w
														// 4 bits Data mode

	setcurLCD(0,0) ;									// ϥ setcurLCD( ) ]wЩ (0,0)
	putrsLCD( My_String4 ) ;							// Nsb Program Memory rϥ
														// putrsLCD( ) LX LCD
			
	setcurLCD(0,1) ;									// ϥ setcurLCD( ) ]wЩ (0,0)
	putrsLCD( My_String8 ) ;							// Nsb Program Memory rϥ
														// putrsLCD( ) LX LCD
			
	putsUART1( (unsigned int *) My_String6 ) ;			// Nsb Program Memory rX
	while((!DataRdyUART1())&&(No_Sec<5000));
	if(No_Sec<5000)
		putsUART1( (unsigned int *) My_String7 ) ;		// Nsb Program Memory rX
	else
		putsUART1( (unsigned int *) My_String9 ) ;
	setcurLCD(0,1) ;									// ϥ setcurLCD( ) ]wЩ (0,1)
	putrsLCD( My_String5 ) ;							// Nsb Data Memory rϥ
														// putsLCD( ) LX LCD

														// 5 * 7 Character 
	while(1){
	
	if(!SW5){
		LED7=0;
		LED8=1;
		LATDbits.LATD0=~LATDbits.LATD0;

		Init_ADC1( ) ;										// NADCilƳ]w


		setcurLCD(0,0) ;									// ϥ setcurLCD( ) ]wЩ (0,0)
		putrsLCD( My_String1 ) ;							// Nsb Program Memory rϥ
														// putrsLCD( ) LX LCD
			
		setcurLCD(0,1) ;									// ϥ setcurLCD( ) ]wЩ (0,1)
		putrsLCD( My_String2 ) ;							// Nsb Data Memory rϥ
														// putsLCD( ) LX LCD

		while(SW6) 
		{	
			Show_ADC1( ) ;								// NADCGܩ LCD W 
		}
	}
	
	if(!SW6){
		LED7=1;
		LED8=0;
		LATDbits.LATD0=~LATDbits.LATD0;

		Init_ADC2( ) ;										// NADCilƳ]w

		setcurLCD(0,0) ;									// ϥ setcurLCD( ) ]wЩ (0,0)
		putrsLCD( My_String3 ) ;							// Nsb Program Memory rϥ
														// putrsLCD( ) LX LCD
			
		setcurLCD(0,1) ;									// ϥ setcurLCD( ) ]wЩ (0,1)
		putrsLCD( My_String2 ) ;							// Nsb Data Memory rϥ
														// putsLCD( ) LX LCD
		Init_MCPWM( );

		while(SW5)
		{
			Show_ADC2( ) ;
			PDC1 = PDC2 = PDC3 = (ADCBUF1 << 6);
		
			if (ADCBUF0 > 0x0200)
			{
				OverrideMCPWM(PWM_GEN_1H & PWM_GEN_1L &
						PWM_GEN_2H & PWM_GEN_2L &
						PWM_POUT_3H & PWM_POUT_3L &
						PWM_POUT3H_ACT);
			}
			else
			{
				OverrideMCPWM(PWM_GEN_1H & PWM_GEN_1L &
						PWM_GEN_2H & PWM_GEN_2L &
						PWM_GEN_3H & PWM_GEN_3L );
			}
		}
	}
	}
}

/***********************************************/
// Subroutine to initialize ADC module

void	Init_ADC1(void)
{

	unsigned int Channel, PinConfig, Scanselect, Adcon3_reg, Adcon2_reg, Adcon1_reg;

	ADCON1bits.ADON = 0; /* turn off ADC */

	PinConfig = ENABLE_AN0_ANA &		// Select port pins as analog inputs ADPCFG<15:0>
				ENABLE_AN6_ANA &
				ENABLE_AN8_ANA ;
	Adcon1_reg = ADC_MODULE_ON &		// Turn on A/D module (ADON)
		ADC_IDLE_STOP &					// ADC turned off during idle (ADSIDL)
		ADC_FORMAT_INTG &				// Output in integer format (FORM)
		ADC_CLK_AUTO &					//*Conversion trigger automatically (SSRC)
		ADC_SAMPLE_INDIVIDUAL &			//*nקGSample channels individually (SIMSAM)
		ADC_AUTO_SAMPLING_ON;			//*nקGSample trigger automatically (ASAM)
	Adcon2_reg = ADC_VREF_AVDD_AVSS &	// Voltage reference : +AVdd, -AVss (VCFG)
		ADC_SCAN_ON &					//*nקGScan on (CSCNA)
		ADC_ALT_BUF_OFF &				// Use fixed buffer (BUFM)
		ADC_ALT_INPUT_OFF &				// Does not alternate between MUX A & MUX B (ALTS)
		ADC_CONVERT_CH0 &				//*nקGConvert only channel 0 (CHPS)
		ADC_SAMPLES_PER_INT_3;			//*nקG3 samples between interrupt (SMPI)
	Adcon3_reg = ADC_SAMPLE_TIME_16 &	// Auto-Sample time (SAMC)
		ADC_CONV_CLK_SYSTEM &			// Use system clock (ADRC)
		ADC_CONV_CLK_4Tcy;				// Conversion clock = 4 Tcy (ADCS)
										// ADCS = 2*(154ns)/(1/Fcy)-1 = 3.5416
										// TAD = (ADCS+1)/(2*Fcy) = 169.54ns
	Scanselect = SKIP_SCAN_AN1 &SKIP_SCAN_AN2  &	//*nקGADC scan channel 0,1,6(ADCSSL)
				SKIP_SCAN_AN3 & SKIP_SCAN_AN4  & 
				SKIP_SCAN_AN5 & SKIP_SCAN_AN7  & 
				SKIP_SCAN_AN9  & SKIP_SCAN_AN10 &
				SKIP_SCAN_AN11 & SKIP_SCAN_AN12 &
				SKIP_SCAN_AN13 & SKIP_SCAN_AN14 &
				SKIP_SCAN_AN15;
	OpenADC10(Adcon1_reg, Adcon2_reg, Adcon3_reg, PinConfig, Scanselect);

	Channel = ADC_CH0_POS_SAMPLEA_AN0 &	//*nקGCH0 Pos. : AN0, AN6, AN8, 
			ADC_CH0_POS_SAMPLEA_AN6 &	// Neg. : Nominal Vref- Defined in ADCON2
			ADC_CH0_POS_SAMPLEA_AN8 &
			ADC_CH0_NEG_SAMPLEA_NVREF ;	// (ADCHS)
	SetChanADC10(Channel);

	ConfigIntADC10(ADC_INT_DISABLE);	// Disable ADC interrupt

}

void	Init_ADC2(void)
{

	unsigned int Channel, PinConfig, Scanselect, Adcon3_reg, Adcon2_reg, Adcon1_reg;

	ADCON1bits.ADON = 0; /* turn off ADC */

	PinConfig = ENABLE_AN0_ANA &		// Select port pins as analog inputs ADPCFG<15:0>
				ENABLE_AN6_ANA ;

	Adcon1_reg = ADC_MODULE_ON &		// Turn on A/D module (ADON)
		ADC_IDLE_STOP &					// ADC turned off during idle (ADSIDL)
		ADC_FORMAT_INTG &				// Output in integer format (FORM)
		ADC_CLK_AUTO &					//*Conversion trigger automatically (SSRC)
		ADC_SAMPLE_SIMULTANEOUS &		//*Sample channels simultaneously (SIMSAM)
		ADC_AUTO_SAMPLING_OFF &			//*Sample trigger automatically (ASAM)
		ADC_SAMP_OFF ;					//									

	Adcon2_reg = ADC_VREF_AVDD_AVSS &	// Voltage reference : +AVdd, -AVss (VCFG)
		ADC_SCAN_OFF &					// Scan off (CSCNA)
		ADC_ALT_BUF_OFF &				// Use fixed buffer (BUFM)
		ADC_ALT_INPUT_OFF &				// Does not alternate between MUX A & MUX B (ALTS)
		ADC_CONVERT_CH_0A &				// Convert only channel 0 (CHPS)
		ADC_SAMPLES_PER_INT_1;			//*2 samples between interrupt (SMPI)

	Adcon3_reg = ADC_SAMPLE_TIME_16 &	// Auto-Sample time (SAMC)
		ADC_CONV_CLK_SYSTEM &			// Use system clock (ADRC)
		ADC_CONV_CLK_4Tcy;				// Conversion clock = 4 Tcy (ADCS)
										// ADCS = 2*(154ns)/(1/Fcy)-1 = 3.5416
										// TAD = (ADCS+1)/(2*Fcy) = 169.54ns

	Scanselect = SCAN_NONE;				// ADC scan no channel (ADCSSL)

	OpenADC10(Adcon1_reg, Adcon2_reg, Adcon3_reg, PinConfig, Scanselect);

	Channel = ADC_CH0_POS_SAMPLEA_AN6 & //*CH0 Pos. : AN6, Neg. : Nominal Vref- Defined in ADCON2
			ADC_CH0_NEG_SAMPLEA_NVREF &
			ADC_CHX_POS_SAMPLEA_AN0AN1AN2 &
			ADC_CHX_NEG_SAMPLEA_NVREF ;		// (ADCHS)

	SetChanADC10(Channel);

	ConfigIntADC10(ADC_INT_DISABLE);	// Disable ADC interrupt

}

/***********************************************/
// Subroutine to show ADC on LCD

void	Show_ADC1(void)
{
	unsigned int ADCValue[3];
	
	IFS0bits.ADIF = 0;			//*nקGH_XˬdഫA
	ADCON1bits.ASAM = 1;			//*start sampling & conversion
	while(!IFS0bits.ADIF) ;
	ADCON1bits.ASAM = 0;			//*stop sampling & conversion

	ADCValue[0] = (ReadADC10(0)>>2) ;
	ADCValue[1] = (ReadADC10(1)>>2) ;
	ADCValue[2] = ReadADC10(2) ;

	setcurLCD(12,1) ;					// Set LCD cursor
	put_Num_LCD( ADCValue[0] ) ;	// NഫGHQiƦrܦܲGܾ
		
	setcurLCD(4,1) ;					// Set LCD cursor
	put_Num_LCD( ADCValue[1] ) ;	// NഫGHQiƦrܦܲGܾ
		
	setcurLCD(14,0) ;			// Set LCD cursor
	putcLCD( AN_Key( ADCValue[2] ) );				// Nഫ䵲GHƦrܦܲGܾ
}

void	Show_ADC2(void)
{
	unsigned int ADCValue;
	int			Loop ;

	ADCValue = 0;				// clear ADCValue

	ADCON1bits.SAMP = 1; 						// start sampling & conversion 
	for ( Loop = 0 ; Loop < 100 ; Loop ++ ) ;	//								
	ADCON1bits.SAMP = 0; 						// stop sampling & conversion 

	while (BusyADC10()); 		// conversion done?

	ADCValue = ReadADC10(0) ;
	setcurLCD(4,1) ;			// Set LCD cursor
	put_Num_LCD( ADCValue >> 2 ) ;	// NഫGHQiƦrܦܲGܾ

	ADCValue = ReadADC10(1) ;
	setcurLCD(12,1) ;			// Set LCD cursor		
	put_Num_LCD( ADCValue >> 2 ) ;	// NഫGHQiƦrܦܲGܾ

}

/***********************************************/
// Subroutine to ANALOG KEYS on LCD

unsigned char	AN_Key(unsigned int ADCValue)
{

	unsigned char SW;

// HTഫG̰Ӧ줸P_䪺A
// hӫPɫUɡAHşC䬰
	ADCValue >>=6;
		
	if (ADCValue == 0)	(SW = '1') ;
	else 
	{	if(ADCValue <= 8) (SW = '2') ;
		else 
		{	if(ADCValue <= 10) (SW = '3') ;
			else 
			{	if(ADCValue <= 12) (SW = '4') ;
				else (SW = ' ') ;
			}
		}
	}

	return SW;
}

void Init_MCPWM(void)
{
	/* Holds the PWM interrupt configuration value*/
	unsigned int config;
	/* Holds the value to be loaded into dutycycle register */
	unsigned int period;
	/* Holds the value to be loaded into special event compare register */
	unsigned int sptime;
	/* Holds PWM configuration value */
	unsigned int config1;
	/* Holds the value be loaded into PWMCON1 register */
	unsigned int config2;
	/* Holds the value to configure the special event trigger postscale and dutycycle */
	unsigned int config3;
	/* The value of dutycyclereg determines the duty cycle register(PDCx) to be written */
	unsigned int dutycyclereg;
	unsigned int dutycycle;
	unsigned char updatedisable;
	/* Configure pwm interrupt enable/disable and set interrupt priorties */
	config = (PWM_INT_DIS & PWM_FLTA_DIS_INT & PWM_INT_PR1
			& PWM_FLTA_INT_PR0);
	ConfigIntMCPWM( config );
	/* Configure PWM to generate square wave of 50% duty cycle */
	dutycyclereg = 1;
	dutycycle = 0x3FFF;
	updatedisable = 0;
	SetDCMCPWM(dutycyclereg,dutycycle,updatedisable);
//	PDC1=0x3FFF;
	PDC2=0x3FFF;
	PDC3=0x3FFF;

	/* Setup Fault Control */
	SetMCPWMFaultA(PWM_OVA1H_ACTIVE & 
				PWM_FLTA_MODE_CYCLE &
				PWM_FLTA1_EN & PWM_FLTA2_DIS & PWM_FLTA3_DIS ); 
	period = 0x7fff;
	sptime = 0x0;
	config1 = (PWM_EN & PWM_IDLE_STOP & PWM_OP_SCALE16
		& PWM_IPCLK_SCALE64 &
		PWM_MOD_UPDN);
	config2 = (PWM_MOD1_COMP & PWM_MOD2_COMP & PWM_MOD3_COMP &
		PWM_PEN3H & PWM_PEN2H & PWM_PEN1H & 
		PWM_PEN3L & PWM_PEN2L & PWM_PEN1L);
	config3 = (PWM_SEVOPS1 & PWM_OSYNC_PWM & PWM_UEN);
	OpenMCPWM(period,sptime,config1,config2,config3);
}

/***********************************************/
// Subroutine to initialize UART module

void	Init_UART(void)
{
	/* Holds the value of baud register */
	unsigned int baudvalue;
	/* Holds the value of uart config reg */
	unsigned int U1MODEvalue;
	/* Holds the information regarding uart
	TX & RX interrupt modes */
	unsigned int U1STAvalue;
	/* Turn off UART1module */
	CloseUART1();
	/* Configure uart1 receive and transmit interrupt */
	ConfigIntUART1(UART_RX_INT_DIS & UART_RX_INT_PR6 &
	UART_TX_INT_DIS & UART_TX_INT_PR2);
	/* Setup the Buad Rate Generator */
	baudvalue = 95;			//UxBRG = ( (FCY/Desired Baud Rate)/16) V 1
							//UxBRG = ( (7372800*2/9600)/16-1) = 95
	/* Configure UART1 module to transmit 8 bit data with one stopbit.
	Also Enable loopback mode */
	U1MODEvalue = UART_EN & UART_IDLE_CON &
				UART_DIS_WAKE & UART_DIS_LOOPBACK &
				UART_DIS_ABAUD & UART_NO_PAR_8BIT &
				UART_1STOPBIT;
	U1STAvalue = UART_INT_TX_BUF_EMPTY &
				UART_TX_PIN_NORMAL &
				UART_TX_ENABLE & UART_INT_RX_CHAR &
				UART_ADR_DETECT_DIS &
				UART_RX_OVERRUN_CLEAR;
	OpenUART1(U1MODEvalue, U1STAvalue, baudvalue);

	return;

}
